# Run as enderman, at position of a possible observer, facing the enderman
###############################################################################

# Nautilus particle represents position of command
#execute if score dontblink debug_particles matches 1 run particle nautilus ~ ~ ~


tag @s remove obscured


# White particle represents position of facing_check cloud
execute facing entity @s eyes run summon area_effect_cloud ^ ^ ^2 {Tags:[facing_check]}
execute if score dontblink debug_particles matches 1 facing entity @s eyes run particle dust 1.0 1.0 1.0 0.75 ^ ^ ^2

# Smaller white particle represents player look direction -- if it's close enough to the facing_check cloud, then the enderman is possibly being observed and a raycast must be tested
execute if score dontblink debug_particles matches 1 run execute rotated as @p positioned ^ ^ ^2 run particle dust 1.0 1.0 1.0 0.25



# If the following command succeeds, then the player is looking in the general direction of the enderman, and we need to test if it's actually visible via raycasts
execute rotated as @p positioned ^ ^ ^2 if entity @e[type=minecraft:area_effect_cloud,tag=facing_check,distance=..2.25] positioned ^ ^ ^-2 facing entity @s feet run function dontblink:triple_raycast


# If the following command succeeds, the player's crosshair is very close to the enderman, and so its AI will be reenabled so the player can provoke it via staring
execute if entity @p[gamemode=!spectator,gamemode=!creative] rotated as @p positioned ^ ^ ^2 if entity @e[type=minecraft:area_effect_cloud,tag=facing_check,distance=..0.25] run tag @s add crosshair_on


kill @e[tag=facing_check]