# If an enderman doesn't have a sound_cooldown score, add it
execute as @e[type=enderman] unless score @s sound_cooldown = @s sound_cooldown run scoreboard players set @s sound_cooldown 0
# Decrement enderman sound cooldown
execute as @e[type=enderman] if score @s sound_cooldown matches 1.. run scoreboard players remove @s sound_cooldown 1

execute as @a[gamemode=!spectator] at @s anchored eyes run summon area_effect_cloud ^ ^ ^ {Tags:[observer]}

# Reset endermen (appropriate changes will be (re)applied before the end of the tick)
tag @e[type=enderman] remove observed
tag @e[type=enderman] remove not_on_ground
tag @e[type=enderman] remove crosshair_on
execute as @e[type=enderman] run data merge entity @s {NoAI:0}
execute as @e[type=enderman] at @s if block ~ ~-0.1 ~ #dontblink:non_solid run tag @s add not_on_ground
execute as @e[type=enderman] run data merge entity @s {Attributes:[{Name:"minecraft:generic.movement_speed",Base:0.3d}]}


execute if score dontblink affect_non_hostile matches 1 run execute as @e[type=enderman] at @s run function dontblink:enderman_tick
execute unless score dontblink affect_non_hostile matches 1 run execute as @e[type=enderman,nbt=!{AngerTime:0}] at @s run function dontblink:enderman_tick

kill @e[tag=observer]


# Debug glow
execute if score dontblink debug_glow matches 1 as @e[type=enderman,tag=observed,tag=!not_on_ground,tag=!crosshair_on] at @s unless entity @e[type=#dontblink:can_attack_endermen,distance=..5] run effect clear @s glowing
execute if score dontblink debug_glow matches 1 run effect give @e[type=enderman,nbt=!{NoAI:1b}] glowing 1