# Depending on config, either run by every enderman or only hostile endermen
###############################################################################


data merge entity @s {Attributes:[{Name:"minecraft:generic.movement_speed",Base:-1.0d}]}

execute at @e[type=area_effect_cloud,tag=observer] facing entity @s feet run function dontblink:check_facing


# Endermen have NO AI when looked at, unless the player (or some other mobs) are too close, or a player's crosshair is on them, and are given temporary AI (and thus gravity) if they happen to be floating
execute if entity @s[tag=observed,tag=!not_on_ground,tag=!crosshair_on] unless entity @e[type=#dontblink:can_attack_endermen,distance=..5] run data merge entity @s {NoAI:1}


# Frozen Endermen always stare at the nearest player (but not necessarily the one they're angry at yet)
execute if score dontblink endermen_stare_back matches 1 if entity @s[nbt={NoAI:1b}] run tp @s ~ ~ ~ facing entity @p feet


# When close enough, unobserved endermen will start running after the player
execute if entity @s[tag=!observed] if entity @e[type=#dontblink:can_attack_endermen,distance=..9] run data merge entity @s {Attributes:[{Name:"minecraft:generic.movement_speed",Base:0.4d}]}


# ...As will observed endermen, though with a much smaller radius
execute if entity @s[tag=observed] if entity @e[type=#dontblink:can_attack_endermen,distance=..3] run data merge entity @s {Attributes:[{Name:"minecraft:generic.movement_speed",Base:0.4d}]}


# Observed endermen will also scream if the player close enough for them to attack
execute as @e[type=enderman,tag=observed,scores={sound_cooldown=0},nbt=!{AngerTime:0}] at @s if entity @e[type=player,gamemode=!creative,gamemode=!spectator,distance=..2.4] run function dontblink:scream