# Run as enderman, at position of a possible observer, facing the enderman
# This function is only run for each player that is looking in the general direction of the enderman
###############################################################################



# These three particle clouds represent the enderman's three raycast targets. The bottommost one is the position of the enderman itself
execute if score dontblink debug_particles matches 1 run execute at @s run particle dust 1.0 1.0 1.0 1.5 ~ ~ ~
execute if score dontblink debug_particles matches 1 run execute at @s run particle dust 0.0 1.0 1.0 1.5 ~ ~1.2 ~
execute if score dontblink debug_particles matches 1 run execute at @s run particle dust 0.0 1.0 1.0 2.0 ~ ~2.4 ~


# FEET
function dontblink:raycast_feet


# TORSO
tag @s remove obscured
execute unless entity @s[tag=observed] at @s run summon area_effect_cloud ~ ~1.2 ~ {Tags:[enderman_torso]}
execute unless entity @s[tag=observed] facing entity @e[tag=enderman_torso] feet run function dontblink:raycast_torso


# HEAD
tag @s remove obscured
execute unless entity @s[tag=observed] at @s run summon area_effect_cloud ~ ~2.4 ~ {Tags:[enderman_head]}
execute unless entity @s[tag=observed] facing entity @e[tag=enderman_head] feet run function dontblink:raycast_head


kill @e[tag=enderman_torso]
kill @e[tag=enderman_head]